<template>
  <aside id="app-sidebar">
    <nav ref="sidenav" class="sidenav" role="tablist" @touchstart="onTouchStart" @touchend="onTouchEnd">
      <ul class="nav flex-column menu">
        <menu-item v-for="item of menus" :key="item.name" @click="toggleSidebar(!collapse, item)" :class="item.classes"
          :name="item.name" :href="item.path" :exact="item.exact" :icon="item.icon" :label="item.menu">

          <b-collapse v-if="item.hasChildren" tag="ul" role="tabpanel" class="sub-nav" accordion="sidenav" :visible="item.open" :id="`sub-${item.name}`">
            <menu-item v-for="child of item.children" :key="child.name" @click="toggleSidebar(!collapse, child)"
              :class="child.classes" :name="child.name" :href="child.path" :exact="child.exact" :label="child.menu">

              <b-collapse v-if="child.hasChildren" tag="ul" role="tabpanel" class="sub-nav" accordion="sidenav" :visible="child.open" :id="`sub-${child.name}`">
                <menu-item v-for="grandChild of child.children" :key="grandChild.name" @click="toggleSidebar(!collapse, grandChild)"
                  :class="grandChild.classes" :name="grandChild.name" :href="grandChild.path" :exact="grandChild.exact" :label="grandChild.menu">
                </menu-item>
              </b-collapse>

            </menu-item>
          </b-collapse>

        </menu-item>
      </ul>
    </nav>

    <div class="sidebar-backdrop" @click="toggleSidebar(!collapse)"></div>
  </aside>
</template>

<script>
import PerfectScrollbar from 'perfect-scrollbar'
import SidebarMenu from './sidebar-menu'
import { sidebarToggler } from '@/mixins'

export default {
  name: 'sidebar',

  mixins: [sidebarToggler],

  components: {
    'menu-item': SidebarMenu
  },

  computed: {
    menus () {
      return this.normailzeRoutes(this.$router.options.routes)
    }
  },

  methods: {
    isOpen (path) {
      return this.$route.path.indexOf(path) === 0
    },

    isExact (item) {
      item.exact = ['/', ''].includes(item.path)

      return this.isSubResource(item) ? false : item.exact
    },

    isSubResource (item) {
      if (!item.exact || !this.$route.name || !item.name.includes('.')) {
        return false
      }

      const routeType = this.$route.name.split('.').pop()
      const itemType = item.name.split('.').pop()

      return this.$route.name === item.name ||
        (itemType === 'index' && ['create', 'edit'].includes(routeType))
    },

    normailzeRoutes (routes, parent = {}, depth = 0) {
      return routes.slice(0).map(({ meta, ...route }) => {
        const item = Object.assign({}, {
          name: route.name || '',
          path: route.path,
          title: meta.title,
          icon: meta.icon || '',
          hasChildren: meta.hasChildren || false,
          classes: [],
          menu: meta.menu === undefined ? meta.title : meta.menu,
          group: meta.group || 'default'
        })

        item.exact = this.isExact(item)

        if (depth > 3) {
          console.warn('The menu only supported 2 depth nested.')
          return item
        }

        if (parent.path) {
          item.path = [parent.path, item.path].join('/')
        }

        if (Array.isArray(route.children) && route.children.length > 0) {
          const parts = route.children[0].name.split('.')
          item.name = parts.splice(0, parts.length - 1).join('.')

          if (item.hasChildren) {
            item.open = this.isOpen(item.path)
            item.classes.push('has-subs')
            item.children = this.normailzeRoutes(route.children, item, depth++)

            if (item.open) {
              item.classes.push('opened')
            }
          }
        }

        return item
      }).filter(item => item.menu !== false)
    }
  },

  mounted () {
    this._ps = new PerfectScrollbar(this.$refs.sidenav)
  },

  beforeDestroy () {
    if (this._ps) {
      this._ps.destroy()
      this._ps = null
    }
  }
}
</script>

<style lang="scss" scoped>
@import '~perfect-scrollbar/css/perfect-scrollbar.css';

#app-sidebar {
  z-index: $zindex-modal-backdrop;
  transition: ease-in-out .34s;
  visibility: visible;
}

#app-sidebar,
.sidebar-backdrop {
  top: $headbar-height;
  position: fixed;
  left: 0;
  bottom: 0;
}

.sidenav {
  height: calc(100vh - (#{$footer-height} + #{$footer-border-width}));
  background-color: $white;
  transition: ease-in-out .34s;
  position: relative;
  overflow: hidden;
  min-width: 200px;
  z-index: 2;

  @include media-breakpoint-up(md) {
    border-right: 1px solid $border-color;
  }
}

.sidebar-backdrop {
  transition: ease-in-out .34s;
  background-color: rgba(0, 0, 0, .3);
  z-index: 1;
  width: 100%;

  @include media-breakpoint-up(md) {
    display: none;
    visibility: hidden;
  }
}

.nav {
  font-size: 14px;
  padding-top: $page-gutter;
  padding-bottom: $grid-gutter-width;

  .sub-nav {
    list-style: none;
    padding-left: 1rem;
    font-size: 13px;

    /deep/ .nav-link {
      padding-left: 30px;
      line-height: 1rem;
    }

    /deep/ .sub-nav {
      padding-left: 0;

      .nav-link {
        padding-left: 40px;
      }
    }
  }
}

#side-footer {
  height: $footer-height;

  @include media-breakpoint-up(md) {
    border-top: $footer-border-width solid $border-color;
  }

  @include media-breakpoint-down(md) {
    position: fixed;
    bottom: 0;
    left: 0;
    z-index: $zindex-modal;
  }
}
</style>
